﻿Imports System.Drawing

Namespace Brushes

    Public Class StandardBrush1 : Inherits Plugin.Brush
        Dim _strokePoint As Api.StrokePoint = Nothing

        Public Overrides Property Image(ByVal point As Api.StrokePoint) As System.Drawing.Image
            Get
                Dim p_(3) As PointF
                Dim size As Size = size.Empty
                If Me._strokePoint IsNot Nothing Then
                    Dim x = point.X
                    Dim _x = Me._strokePoint.X
                    Dim y = point.Y
                    Dim _y = Me._strokePoint.Y
                    Dim pressure = point.Pressure
                    Dim angle = IIf((y - _y) <> 0, Math.Atan(-(x - _x) / (y - _y)), 0)
                    Dim width As Single = Me._image.Width * pressure
                    Dim height As Single = Me._image.Height * pressure

                    Dim p() As PointF = New PointF() {New PointF(0, 0), New PointF(width, 0), New PointF(0, height), New PointF(width, height)}
                    Dim q = New PointF(width / 2, height / 2)
                    For idx = LBound(p) To UBound(p)
                        p_(idx) = f(p(idx), angle, q)
                    Next
                    size.Width = Math.Round(width, 0)
                    size.Height = Math.Round(height, 0)
                Else
                    size.Width = 1
                    size.Height = 1
                    'p_ = New PointF() {New PointF(0, 0), New PointF(Me._image.Width, 0), New PointF(0, Me._image.Height), New PointF(Me._image.Width, Me._image.Height)}
                    p_ = New PointF() {New PointF(0, 0), New PointF(size.Width, 0), New PointF(size.Height, 1), New PointF(size.Width, size.Height)}
                End If
                If (size.Width > 0 AndAlso size.Height > 0) Then
                    Image = New Bitmap(size.Width, size.Height)
                    Dim g = Graphics.FromImage(Image)
                    g.DrawImage(Me._image, New PointF() {p_(0), p_(1), p_(2)})
                    g.Dispose()
                Else
                    Image = Nothing
                End If
                Me._strokePoint = point
            End Get
            Set(ByVal value As System.Drawing.Image)
                Me._image = value
            End Set
        End Property

        Function f(ByVal p As PointF, ByVal r As Double, ByVal q As PointF) As PointF
            f.X = (p.X - q.X) * Math.Cos(r) - (p.Y - q.Y) * Math.Sin(r) + q.X
            f.Y = (p.X - q.X) * Math.Sin(r) + (p.Y - q.Y) * Math.Cos(r) + q.Y
        End Function

        Public Sub New()
            Me._image = New Bitmap(System.IO.Path.Combine(System.Windows.Forms.Application.StartupPath, System.IO.Path.Combine("Plugin", "i.png")))
            Me._separation = 1.0F
            Me.__p = Nothing
        End Sub

    End Class

End Namespace

Namespace Commands

    Public Class StandardBrush1Command : Inherits Plugin.Command
        Dim _brush As Brushes.StandardBrush1
        Dim _env As Api.Invoker = Nothing

        Public Overrides Sub Invoke(ByVal env As Api.Invoker)
            If Me._brush Is Nothing OrElse env IsNot Me._env Then
                Me._brush = New Brushes.StandardBrush1
                Me._env = env
            End If
            Me._brush.Draw(env.Canvas, env.StrokePoints)
        End Sub

    End Class

End Namespace
