﻿Class Tablet
    Dim _strokeModifier As Dictionary(Of Type, Type) = New Dictionary(Of Type, Type)
    Dim _commands As Dictionary(Of Type, List(Of Type)) = New Dictionary(Of Type, List(Of Type))

    Property StrokeModifier(ByVal key As Type) As Api.StrokeModifier
        Get
            If Not Me._strokeModifier.ContainsKey(key) Then
                Me._strokeModifier(key) = Type.GetType("WindowsApplication1.Plugin.Strokes.NullStroke,WindowsApplication1.Plugin", True)
            End If
            StrokeModifier = DirectCast(Me._strokeModifier(key).GetConstructor(Type.EmptyTypes).Invoke(Nothing), Api.StrokeModifier)
        End Get
        Set(ByVal value As Api.StrokeModifier)
            Me._strokeModifier(key) = value.GetType()
        End Set
    End Property

    Property Commands(ByVal key As Type) As List(Of Api.Command)
        Get
            If Not Me._commands.ContainsKey(key) Then
                Me._commands(key) = New List(Of Type)
            End If
            Dim enu = Me._commands(key).GetEnumerator()
            Commands = New List(Of Api.Command)
            Do While enu.MoveNext()
                Commands.Add(DirectCast(enu.Current.GetConstructor(Type.EmptyTypes).Invoke(Nothing), Api.Command))
            Loop
        End Get
        Set(ByVal value As List(Of Api.Command))
            Dim enu = value.GetEnumerator()
            Me._commands(key) = New List(Of Type)
            Do While enu.MoveNext()
                Me._commands(key).Add(enu.Current.GetType())
            Loop
        End Set
    End Property

    Public ReadOnly Property Id() As String
        Get
            Id = Me._id
        End Get
    End Property

    Shared _us = New Dictionary(Of String, Tablet)
    Dim _id As String
    Shared ReadOnly Property Instance(Optional ByVal id As String = Nothing) As Tablet
        Get
            If id Is Nothing OrElse Not Tablet._us.ContainsKey(id) Then
                Dim i = New Tablet(id)
                id = i._id
                Tablet._us(id) = i
            End If
            Instance = Tablet._us(id)
        End Get
    End Property

    Private Sub New(Optional ByVal id As String = Nothing)
        If id Is Nothing Then
            id = Me.GetHashCode()
        End If
        Me._id = id
    End Sub

End Class
