﻿Public Class StrokePoint : Implements Api.StrokePoint
    Dim _location As System.Drawing.PointF
    Dim _pressure As Double

    Public Property Location() As System.Drawing.PointF Implements Api.StrokePoint.Location
        Get
            Location = Me._location
        End Get
        Set(ByVal value As System.Drawing.PointF)
            Me._location = value
        End Set
    End Property

    Public Property X() As Single Implements Api.StrokePoint.X
        Get
            X = Me._location.X
        End Get
        Set(ByVal value As Single)
            Me._location.X = value
        End Set
    End Property

    Public Property Y() As Single Implements Api.StrokePoint.Y
        Get
            Y = Me._location.Y
        End Get
        Set(ByVal value As Single)
            Me._location.Y = value
        End Set
    End Property

    Public Property Pressure() As Double Implements Api.StrokePoint.Pressure
        Get
            Pressure = Me._pressure
        End Get
        Set(ByVal value As Double)
            Me._pressure = value
        End Set
    End Property

    Public Sub New(ByVal location As System.Drawing.PointF, ByVal pressure As Double)
        MyClass.New()
        Me._location = location
        Me._pressure = pressure
    End Sub

    Public Sub New()
        Me._location = System.Drawing.Point.Empty
        Me._pressure = 0
    End Sub

End Class

Public Structure StrokePointPair : Implements Api.StrokePointPair
    Dim StartPoint As Api.StrokePoint
    Dim EndPoint As Api.StrokePoint

    Public Function AsArray() As Api.StrokePoint() Implements Api.StrokePointPair.AsArray
        AsArray = New StrokePoint() {Me.StartPoint, Me.EndPoint}
    End Function

    Public Function AsList() As List(Of Api.StrokePoint) Implements Api.StrokePointPair.AsList
        AsList = New List(Of Api.StrokePoint)
        AsList.Add(Me.StartPoint)
        AsList.Add(Me.EndPoint)
    End Function

    Public Sub New(ByVal startPoint As Api.StrokePoint, ByVal endPoint As Api.StrokePoint)
        Me.StartPoint = startPoint
        Me.EndPoint = endPoint
    End Sub

End Structure
